(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["CodeHighlightAdapter"] = factory();
	else
		root["CodeHighlightAdapter"] = factory();
})(self, function() {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 978:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ lib_esm),
  "gloader": () => (/* binding */ gloader),
  "loadCss": () => (/* reexport */ loadCss),
  "loadScript": () => (/* reexport */ loadScript),
  "setDefaultOption": () => (/* reexport */ setDefaultOption)
});

;// CONCATENATED MODULE: ./node_modules/@cnblogs/load-script-css/dist/lib-esm/option.js
var defaultTimeoutSeconds = 5;


;// CONCATENATED MODULE: ./node_modules/@cnblogs/load-script-css/dist/lib-esm/create-element.js
var createElement = function (htmlTagName, buildElement) {
    var el = document.createElement(htmlTagName);
    buildElement(el);
    return el;
};


;// CONCATENATED MODULE: ./node_modules/@cnblogs/load-script-css/dist/lib-esm/load-resource.js
var _this = undefined;


var loadingPromiseMaps = [];
var tryClearTimeout = function (timeoutId) {
    if (timeoutId) {
        clearTimeout(timeoutId);
    }
};
var findLoadingPromise = function (id, url) {
    var map = loadingPromiseMaps.find(function (x) { return (id && x[0] === id) || x[0] === url; });
    var _a = map !== null && map !== void 0 ? map : [], promise = _a[1];
    return promise;
};
var removeFromLoadingPromiseMap = function (id, url) {
    var idx = loadingPromiseMaps.findIndex(function (x) { return (id && x[0] === id) || x[0] === url; });
    if (idx >= 0) {
        loadingPromiseMaps.splice(idx, 1);
    }
};
var loadResource = function (_a) {
    var _b, _c;
    var url = _a.url, id = _a.id, timeoutSeconds = _a.timeoutSeconds, appendTo = _a.appendTo, hostElementTagName = _a.hostElementTagName, beforeElementCreateCallback = _a.beforeElementCreateCallback;
    var _document = appendTo ? appendTo.ownerDocument : document;
    var _window = (_c = (_b = _document.defaultView) !== null && _b !== void 0 ? _b : _document.parentWindow) !== null && _c !== void 0 ? _c : window;
    var isDifferentCtx = _document !== document;
    var promise = findLoadingPromise(isDifferentCtx ? 'load-resource-to-another-window-context-' + _window.name + '-' + id : id, url);
    if (promise)
        return promise;
    var loadingEl = _document.querySelector("".concat(hostElementTagName, "#").concat(id));
    loadingEl = !loadingEl
        ? hostElementTagName === 'script' && _document.querySelector("script[src=\"".concat(url, "\"]"))
        : loadingEl;
    loadingEl = !loadingEl
        ? hostElementTagName === 'link' && _document.querySelector("link[href=\"".concat(url, "\"]"))
        : loadingEl;
    if (loadingEl)
        return Promise.resolve(loadingEl);
    promise = new Promise(function (resolve, reject) {
        createElement(hostElementTagName, function (el) {
            el.id = id !== null && id !== void 0 ? id : '';
            appendTo !== null && appendTo !== void 0 ? appendTo : (appendTo = _document.head);
            timeoutSeconds = timeoutSeconds <= 0 ? defaultTimeoutSeconds : timeoutSeconds;
            if (el instanceof HTMLLinkElement) {
                el.href = url;
                el.rel = 'stylesheet';
                el.type = 'text/css';
            }
            else if (el instanceof HTMLScriptElement) {
                el.src = url;
                el.type = 'text/javascript';
                el.defer = true;
            }
            var timeoutId;
            el.onload = function () {
                tryClearTimeout(timeoutId);
                removeFromLoadingPromiseMap(id, url);
                resolve(el);
            };
            el.onerror = function (ev) {
                tryClearTimeout(timeoutId);
                el.remove();
                removeFromLoadingPromiseMap(id, url);
                reject(ev);
            };
            beforeElementCreateCallback === null || beforeElementCreateCallback === void 0 ? void 0 : beforeElementCreateCallback.call(_this, el);
            appendTo.append(el);
            timeoutId = setTimeout(function () {
                tryClearTimeout(timeoutId);
                el.remove();
                removeFromLoadingPromiseMap(id, url);
                reject("timeout after ".concat(timeoutSeconds, " seconds"));
            }, timeoutSeconds * 1000);
        });
    });
    loadingPromiseMaps.push([id ? id : url, promise]);
    return promise;
};


;// CONCATENATED MODULE: ./node_modules/@cnblogs/load-script-css/dist/lib-esm/default-option.js
/**
 * @internal
 */
var defaultValue = {};
/**
 * @public
 * @param value
 */
var setDefaultOption = function (value) { return Object.assign(defaultValue, value); };
/**
 * @internal
 */
var getDefaultOption = function () { return defaultValue; };


;// CONCATENATED MODULE: ./node_modules/@cnblogs/load-script-css/dist/lib-esm/load-script.js



/**
 * @public
 * @param src
 * @param id
 * @param timeoutSeconds
 * @param appendTo
 * @param executionStrategy
 */
var loadScript = function (_a) {
    var _b;
    var src = _a.src, id = _a.id, timeoutSeconds = _a.timeoutSeconds, appendTo = _a.appendTo, executionStrategy = _a.executionStrategy;
    return loadResource({
        url: src,
        hostElementTagName: 'script',
        timeoutSeconds: (_b = timeoutSeconds !== null && timeoutSeconds !== void 0 ? timeoutSeconds : getDefaultOption().timeoutSeconds) !== null && _b !== void 0 ? _b : defaultTimeoutSeconds,
        id: id,
        appendTo: appendTo !== null && appendTo !== void 0 ? appendTo : getDefaultOption().appendTo,
        beforeElementCreateCallback: function (el) {
            if (el instanceof HTMLScriptElement) {
                switch (executionStrategy !== null && executionStrategy !== void 0 ? executionStrategy : getDefaultOption().executionStrategy) {
                    case 'async':
                        el.async = true;
                        el.defer = false;
                        break;
                    default:
                        el.defer = true;
                        el.async = false;
                }
            }
        },
    });
};


;// CONCATENATED MODULE: ./node_modules/@cnblogs/load-script-css/dist/lib-esm/load-css.js



/**
 * @public
 * @param href
 * @param timeoutSeconds
 * @param id
 * @param appendTo
 */
var loadCss = function (_a) {
    var _b;
    var href = _a.href, timeoutSeconds = _a.timeoutSeconds, id = _a.id, appendTo = _a.appendTo;
    return loadResource({
        url: href,
        hostElementTagName: 'link',
        timeoutSeconds: (_b = timeoutSeconds !== null && timeoutSeconds !== void 0 ? timeoutSeconds : getDefaultOption().timeoutSeconds) !== null && _b !== void 0 ? _b : defaultTimeoutSeconds,
        id: id,
        appendTo: appendTo !== null && appendTo !== void 0 ? appendTo : getDefaultOption().appendTo,
    });
};


;// CONCATENATED MODULE: ./node_modules/@cnblogs/load-script-css/dist/lib-esm/index.js



/**
 * @public
 */
var gloader = {
    loadScript: loadScript,
    loadCss: loadCss,
    setDefaultOption: setDefaultOption,
};



/* harmony default export */ const lib_esm = (gloader);


/***/ }),

/***/ 408:
/***/ (() => {

// extracted by mini-css-extract-plugin


/***/ }),

/***/ 302:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AdapterOptionsProvider = void 0;
var highlighter_option_1 = __webpack_require__(907);
var AdapterOptionsProvider;
(function (AdapterOptionsProvider) {
    var _options = Object.assign({}, highlighter_option_1.DefaultAdapterOptions);
    AdapterOptionsProvider.set = function (value) {
        Object.assign(_options, value);
    };
    AdapterOptionsProvider.get = function () { return _options; };
})(AdapterOptionsProvider = exports.AdapterOptionsProvider || (exports.AdapterOptionsProvider = {}));


/***/ }),

/***/ 189:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.BaseHighlighter = void 0;
var utils_1 = __webpack_require__(651);
var adapter_options_provider_1 = __webpack_require__(302);
var load_script_css_1 = __webpack_require__(978);
var constants_1 = __webpack_require__(743);
/**
 * @public
 */
var BaseHighlighter = /** @class */ (function () {
    function BaseHighlighter() {
        this._isDarkTheme = false;
        this.removeLinkElements('link[rel=stylesheet][prismjs]');
        this.removeLinkElements('link[rel=stylesheet][hljs]');
    }
    Object.defineProperty(BaseHighlighter.prototype, "enableCodeLineNumber", {
        get: function () {
            return false;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseHighlighter.prototype, "adapterOptions", {
        get: function () {
            return adapter_options_provider_1.AdapterOptionsProvider.get();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseHighlighter.prototype, "enableMacStyle", {
        get: function () {
            return this.adapterOptions.enableMacStyle;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseHighlighter.prototype, "isDarkTheme", {
        get: function () {
            return this._isDarkTheme;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseHighlighter.prototype, "linesHighlightedClassToken", {
        get: function () {
            return this.id + '-lines-highlighted';
        },
        enumerable: false,
        configurable: true
    });
    BaseHighlighter.prototype.highlightAllUnder = function (parentEl, beforeHighlightBlock, afterHighlightBlock) {
        return __awaiter(this, void 0, void 0, function () {
            var el, codeBlocks, highlightTasks, _loop_1, _i, codeBlocks_1, codeBlock;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (typeof parentEl === 'string') {
                            el = document.querySelector(parentEl);
                        }
                        else {
                            el = parentEl;
                        }
                        if (!el)
                            return [2 /*return*/];
                        codeBlocks = Array.from(el.querySelectorAll('pre code')).map(function (el) { return el; });
                        if (!(codeBlocks.length > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.ensureResourcesLoaded()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        highlightTasks = [];
                        _loop_1 = function (codeBlock) {
                            var preEl = codeBlock.parentElement;
                            var codeEl = codeBlock;
                            if (beforeHighlightBlock && !beforeHighlightBlock(preEl, codeEl)) {
                                return "continue";
                            }
                            highlightTasks.push(new Promise(function (resolve, reject) {
                                _this.highlight(codeEl).then(function () {
                                    if (afterHighlightBlock) {
                                        afterHighlightBlock(preEl, codeEl);
                                    }
                                    resolve();
                                }, function () { return reject(); });
                            }));
                        };
                        for (_i = 0, codeBlocks_1 = codeBlocks; _i < codeBlocks_1.length; _i++) {
                            codeBlock = codeBlocks_1[_i];
                            _loop_1(codeBlock);
                        }
                        return [4 /*yield*/, Promise.all(highlightTasks)];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BaseHighlighter.prototype.setTheme = function (theme, attributes, isDarkTheme) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var tagId, themeLoaded;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.setIsDarkTheme(isDarkTheme);
                        if (!theme && !this.highlighterOptions.defaultTheme) {
                            throw Error('Theme is required! And default theme not configured!');
                        }
                        if (!theme)
                            theme = this.highlighterOptions.defaultTheme;
                        tagId = "highlighter-theme-".concat(theme);
                        themeLoaded = false;
                        if (!!themeLoaded) return [3 /*break*/, 2];
                        this._themeHref = "".concat(this.highlighterOptions.themeBaseUrl, "/").concat(theme, ".css");
                        return [4 /*yield*/, (0, load_script_css_1.loadCss)({
                                href: this._themeHref,
                                id: tagId,
                                beforeElementCreateCallback: function (el) { return (0, utils_1.setAttributes)(el, attributes); },
                            })
                                .catch(function (err) {
                                console.warn("Failed to load theme\n".concat(err));
                                return false;
                            })
                                .then(function () { return true; })];
                    case 1:
                        if (_b.sent()) {
                            (_a = document.querySelectorAll('link[id*=highlighter-theme-],link[id*=line-numbers-style]')) === null || _a === void 0 ? void 0 : _a.forEach(function (e) {
                                if (e.id === tagId) {
                                    themeLoaded = true;
                                    return;
                                }
                                e.remove();
                            });
                        }
                        _b.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    BaseHighlighter.prototype.resolveContainerElements = function (el) {
        var preEl = null;
        var codeEl = null;
        if (el instanceof HTMLPreElement) {
            preEl = el;
            codeEl = el.querySelector('code');
        }
        else if (el.tagName.toLowerCase() === 'code' && el.parentElement instanceof HTMLPreElement) {
            preEl = el.parentElement;
            codeEl = el;
        }
        if (!codeEl || !preEl) {
            return;
        }
        return [preEl, codeEl];
    };
    BaseHighlighter.prototype.loadStyles = function (attributes) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var styles, tasks, _i, styles_1, style;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        styles = (_a = this.highlighterOptions.stylesheets) !== null && _a !== void 0 ? _a : [];
                        tasks = [];
                        for (_i = 0, styles_1 = styles; _i < styles_1.length; _i++) {
                            style = styles_1[_i];
                            tasks.push((0, load_script_css_1.loadCss)({
                                href: style.href,
                                id: style.tagId,
                                beforeElementCreateCallback: function (el) { return (0, utils_1.setAttributes)(el, attributes); },
                            }));
                        }
                        return [4 /*yield*/, Promise.all(tasks)];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BaseHighlighter.prototype.tryApplyLang = function (el) {
        var _a, _b, _c, _d, _e, _f;
        if (!el)
            return '';
        var classes = Array.from(el.classList);
        var parentElementTagName = (_c = (_b = (_a = el.parentElement) === null || _a === void 0 ? void 0 : _a.tagName) === null || _b === void 0 ? void 0 : _b.toLowerCase()) !== null && _c !== void 0 ? _c : '';
        if (classes.findIndex(function (x) { return x.startsWith('language-'); }) < 0 && parentElementTagName === 'pre') {
            var preClasses = Array.from((_e = (_d = el.parentElement) === null || _d === void 0 ? void 0 : _d.classList) !== null && _e !== void 0 ? _e : []);
            var lang = preClasses.find(function (x) { return x.startsWith('language-'); });
            if (lang) {
                el.classList.add(lang);
            }
        }
        return (_f = Array.from(el.classList).find(function (x) { return x.startsWith('language-'); })) !== null && _f !== void 0 ? _f : '';
    };
    BaseHighlighter.prototype.onHighlighting = function (engine, preEl, codeEl) {
        this.setBodyClass(engine);
        this.setEngineClassToken(this.id, preEl);
        this.removeLinesHighlightedClassToken(preEl, codeEl);
        var macStyleAttrKey = 'data-mac-style';
        if (this.enableMacStyle) {
            preEl.setAttribute(macStyleAttrKey, 'true');
        }
        else {
            preEl.removeAttribute(macStyleAttrKey);
        }
    };
    BaseHighlighter.prototype.onHighlighted = function (engine, preEl, codeEl) {
        for (var _i = 0, _a = [preEl, codeEl]; _i < _a.length; _i++) {
            var e = _a[_i];
            if (this.isDarkTheme) {
                e.setAttribute('data-dark-theme', 'true');
            }
            else {
                e.removeAttribute('data-dark-theme');
            }
        }
    };
    BaseHighlighter.prototype.setEngineClassToken = function (engine, preEl) {
        var classes = [constants_1.PrismjsEngineToken, constants_1.HljsEngineClassToken];
        var codeEl = preEl.querySelector('code');
        var classLists = [codeEl === null || codeEl === void 0 ? void 0 : codeEl.classList, preEl.classList];
        for (var _i = 0, classLists_1 = classLists; _i < classLists_1.length; _i++) {
            var list = classLists_1[_i];
            list === null || list === void 0 ? void 0 : list.remove.apply(list, classes);
            switch (engine) {
                case 'prismjs':
                    list === null || list === void 0 ? void 0 : list.add(classes[0]);
                    break;
                case 'highlight.js':
                    list === null || list === void 0 ? void 0 : list.add(classes[1]);
                    break;
            }
        }
    };
    BaseHighlighter.prototype.removeLinesHighlightedClassToken = function () {
        var els = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            els[_i] = arguments[_i];
        }
        for (var _a = 0, els_1 = els; _a < els_1.length; _a++) {
            var el = els_1[_a];
            var classList = el.classList;
            classList.remove.apply(classList, Array.from(classList).filter(function (x) { return x.endsWith('-lines-highlighted'); }));
        }
    };
    /**
     * 过滤code元素中的内容, e.g. 移除行号元素, html标签等
     * @param el
     */
    BaseHighlighter.prototype.filterCodeContent = function (el) {
        var _a, _b;
        if (!el)
            return '';
        // details下的code元素的innerText属性可能会返回空值, 所以创建一个临时的code元素来处理
        // textContent会忽略<br>元素导致不换行
        // https://gitlab.cnblogs.com/dev/BlogServer/-/issues/3461
        // https://gitlab.cnblogs.com/dev/BlogServer/-/issues/3448
        var codeEl = document.createElement('code');
        codeEl.style.opacity = '0';
        codeEl.style.width = '0';
        codeEl.style.height = '0';
        codeEl.style.whiteSpace = 'pre';
        if (el.tagName.toLowerCase() === 'code') {
            codeEl.innerHTML = el.innerHTML;
        }
        else if (el.tagName.toLowerCase() === 'pre' && el.querySelector('code')) {
            codeEl.innerHTML = (_b = (_a = el.querySelector('code')) === null || _a === void 0 ? void 0 : _a.innerHTML) !== null && _b !== void 0 ? _b : '';
        }
        else {
            return '';
        }
        // remove line numbers generated by prismjs
        var lineNumberRowsEl = codeEl.querySelector('.line-numbers-rows');
        if (lineNumberRowsEl) {
            lineNumberRowsEl.remove();
        }
        // remove line numbers generated by hljs
        var hljsLineNumbersEl = codeEl.querySelectorAll('.hljs-ln-line.hljs-ln-numbers');
        hljsLineNumbersEl === null || hljsLineNumbersEl === void 0 ? void 0 : hljsLineNumbersEl.forEach(function (x) { return x.remove(); });
        document.body.append(codeEl);
        var innerText = codeEl.innerText;
        codeEl.remove();
        el.innerHTML = (0, utils_1.encodeHtml)(innerText);
        return innerText;
    };
    BaseHighlighter.prototype.removeLinkElements = function (selector) {
        var _a;
        (_a = document.querySelectorAll(selector)) === null || _a === void 0 ? void 0 : _a.forEach(function (x) { return x.remove(); });
    };
    BaseHighlighter.prototype.resolveLinesToHighlight = function (el) {
        var attr = el.getAttribute('data-lines-highlight');
        try {
            var parsed = JSON.parse(attr !== null && attr !== void 0 ? attr : '[]');
            return Array.isArray(parsed) ? parsed.map(function (lineNumber) { return lineNumber - 1; }) : [];
        }
        catch (ex) {
            console.warn(ex);
            return undefined;
        }
    };
    BaseHighlighter.prototype.setIsDarkTheme = function (value) {
        this._isDarkTheme = value !== null && value !== void 0 ? value : false;
    };
    BaseHighlighter.prototype.setBodyClass = function (engine) {
        var classes = ['prismjs-engine', 'hljs-engine'];
        var classList = window.document.body.classList;
        classList.remove.apply(classList, classes);
        switch (engine) {
            case 'prismjs':
                classList.add(classes[0]);
                break;
            case 'highlight.js':
                classList.add(classes[1]);
                break;
        }
    };
    return BaseHighlighter;
}());
exports.BaseHighlighter = BaseHighlighter;


/***/ }),

/***/ 743:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.HljsEngineClassToken = exports.PrismjsEngineToken = exports.HighlightedLineToken = void 0;
var highlightedLineToken = 'highlighted-line';
exports.HighlightedLineToken = highlightedLineToken;
var prismjsEngineClassToken = 'highlighter-prismjs';
exports.PrismjsEngineToken = prismjsEngineClassToken;
var hljsEngineClassToken = 'highlighter-hljs';
exports.HljsEngineClassToken = hljsEngineClassToken;


/***/ }),

/***/ 907:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.CnblogsPresetAdapterOptions = exports.DefaultAdapterOptions = void 0;
/**
 * @public
 */
exports.DefaultAdapterOptions = {
    enableCodeLineNumber: true,
    enableMacStyle: false,
    prism: {
        scriptPath: '/prism.min.js',
        autoLoaderPluginPath: '',
        lineNumberPluginPath: '',
        stylesheets: [],
        themeBaseUrl: '',
        defaultTheme: '',
    },
    hljs: {
        scriptPath: '/highlight.min.js',
        lineNumberPluginPath: '/highlightjs-line-numbers.min.js',
        stylesheets: [],
        themeBaseUrl: '',
        defaultTheme: '',
    },
};
/**
 * @public
 */
exports.CnblogsPresetAdapterOptions = {
    enableCodeLineNumber: false,
    enableMacStyle: false,
    prism: {
        scriptPath: 'https://common.cnblogs.com/prism/prism.js?v=1.23.0',
        lineNumberPluginPath: 'https://common.cnblogs.com/prism/plugins/line-numbers/prism-line-numbers.min.js',
        autoLoaderPluginPath: 'https://common.cnblogs.com/prism/plugins/autoloader/prism-autoloader.min.js',
        lineNumberStylePath: 'https://common.cnblogs.com/prism/plugins/line-numbers/prism-line-numbers.css',
        themeBaseUrl: 'https://www.cnblogs.com/css/prismjs',
        defaultTheme: 'prism-vs',
        stylesheets: [],
    },
    hljs: {
        scriptPath: 'https://common.cnblogs.com/highlight/11.4.0/highlight.min.js',
        lineNumberPluginPath: 'https://common.cnblogs.com/scripts/highlightjs-line-numbers.min.js',
        stylesheets: [],
        themeBaseUrl: 'https://www.cnblogs.com/css/hljs',
        defaultTheme: 'cnblogs',
    },
};


/***/ }),

/***/ 285:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.HighlightersFactory = void 0;
var highlighter_option_1 = __webpack_require__(907);
var hljs_highlighter_1 = __webpack_require__(794);
var prism_highlighter_1 = __webpack_require__(931);
var adapter_options_provider_1 = __webpack_require__(302);
/**
 * @public
 */
var HighlightersFactory = /** @class */ (function () {
    function HighlightersFactory() {
    }
    HighlightersFactory.configCodeHighlightOptions = function (options) {
        adapter_options_provider_1.AdapterOptionsProvider.set(options);
    };
    HighlightersFactory.useCnblogsCodeHighlightOptions = function () {
        this.configCodeHighlightOptions(highlighter_option_1.CnblogsPresetAdapterOptions);
    };
    HighlightersFactory.createCodeHighlighter = function (engine, theme, options) {
        if (options)
            this.configCodeHighlightOptions(options);
        var highlighter;
        switch (engine) {
            case 'highlight.js':
                highlighter = new hljs_highlighter_1.HljsHighlighter();
                break;
            case 'prismjs':
                highlighter = new prism_highlighter_1.PrismHighlighter();
                break;
            default:
                throw Error('unknown highlight engine');
        }
        if (!theme)
            theme = highlighter.highlighterOptions.defaultTheme;
        var themeName = typeof theme === 'string' ? theme : theme.name;
        var isDark = typeof theme === 'string' ? false : theme.isDark;
        highlighter.setTheme(themeName, undefined, isDark).then();
        return highlighter;
    };
    return HighlightersFactory;
}());
exports.HighlightersFactory = HighlightersFactory;


/***/ }),

/***/ 794:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.HljsHighlighter = void 0;
var base_highlighter_1 = __webpack_require__(189);
var utils_1 = __webpack_require__(651);
var hljs_languages_loader_1 = __webpack_require__(248);
var constants_1 = __webpack_require__(743);
var load_script_css_1 = __webpack_require__(978);
var _global = window;
/**
 * @public
 */
var HljsHighlighter = /** @class */ (function (_super) {
    __extends(HljsHighlighter, _super);
    function HljsHighlighter() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._linkAttr = {
            name: 'hljs',
            value: '',
        };
        return _this;
    }
    Object.defineProperty(HljsHighlighter.prototype, "highlighterOptions", {
        get: function () {
            return this.adapterOptions.hljs;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HljsHighlighter.prototype, "id", {
        get: function () {
            return 'highlight.js';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HljsHighlighter.prototype, "linesHighlightedClassToken", {
        get: function () {
            return 'hljs-lines-highlighted';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HljsHighlighter.prototype, "enableCodeLineNumber", {
        get: function () {
            return this.adapterOptions.enableCodeLineNumber;
        },
        enumerable: false,
        configurable: true
    });
    HljsHighlighter.prototype.ensureResourcesLoaded = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, this.loadHljs()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.loadStyles([this._linkAttr])];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        console.error(err_1);
                        return [2 /*return*/];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    HljsHighlighter.prototype.highlight = function (el) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var enableCodeLineNumber, _b, preEl, codeEl, err_2, lang;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this.ensureResourcesLoaded()];
                    case 1:
                        _c.sent();
                        enableCodeLineNumber = this.enableCodeLineNumber;
                        _b = (_a = this.resolveContainerElements(el)) !== null && _a !== void 0 ? _a : [], preEl = _b[0], codeEl = _b[1];
                        if (!preEl || !codeEl)
                            return [2 /*return*/];
                        preEl.classList.remove(constants_1.PrismjsEngineToken);
                        _c.label = 2;
                    case 2:
                        _c.trys.push([2, 5, , 6]);
                        if (!enableCodeLineNumber) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.loadLineNumberPlugin()];
                    case 3:
                        _c.sent();
                        _c.label = 4;
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        err_2 = _c.sent();
                        console.error(err_2);
                        return [3 /*break*/, 6];
                    case 6:
                        this.onHighlighting(this.id, preEl, codeEl);
                        el.classList.remove('hljs-line-numbers');
                        lang = this.tryApplyLang(el);
                        this.filterCodeContent(el);
                        (0, utils_1.adaptSql)(el);
                        return [4 /*yield*/, hljs_languages_loader_1.HljsLanguagesLoader.load(lang, this.highlighterOptions)];
                    case 7:
                        _c.sent();
                        hljs.highlightElement(el);
                        if (enableCodeLineNumber) {
                            if (hljs.lineNumbersValue) {
                                el.innerHTML = hljs.lineNumbersValue(el.innerHTML, {
                                    singleLine: true,
                                });
                                el.classList.add('hljs-line-numbers');
                            }
                            else {
                                console.error('failed to load hljs line numbers plugin!');
                            }
                        }
                        this.highlightLines(preEl);
                        codeEl.classList.add('hljs');
                        this.onHighlighted(this.id, preEl, codeEl);
                        return [2 /*return*/];
                }
            });
        });
    };
    HljsHighlighter.prototype.highlightLines = function (preEl) {
        var codeEl = preEl.querySelector('code');
        if (!codeEl)
            return [];
        var lineNumbers = this.resolveLinesToHighlight(codeEl);
        if (lineNumbers == null || lineNumbers.length <= 0)
            return [];
        var html = codeEl.innerHTML;
        var enableCodeLineNumber = this.adapterOptions.enableCodeLineNumber;
        switch (enableCodeLineNumber) {
            case false:
                {
                    var lines = html.split('\n');
                    for (var _i = 0, lineNumbers_1 = lineNumbers; _i < lineNumbers_1.length; _i++) {
                        var lineNumber = lineNumbers_1[_i];
                        if (lineNumber < 0 || lineNumber >= lines.length)
                            continue;
                        var lineContent = lines[lineNumber];
                        if (lineContent == null)
                            continue;
                        lines[lineNumber] = "<span class=\"".concat(constants_1.HighlightedLineToken, "\">").concat(lineContent, "</span>");
                    }
                    codeEl.innerHTML = "<span class=\"hljs-lines-highlight-wrapper\">".concat(lines.join('\n'), "</span>");
                }
                break;
            default: {
                var lines = Array.from(codeEl.querySelectorAll('tr'));
                for (var _a = 0, lineNumbers_2 = lineNumbers; _a < lineNumbers_2.length; _a++) {
                    var lineNumber = lineNumbers_2[_a];
                    if (lineNumber < 0 || lineNumber >= lines.length)
                        continue;
                    var tableRowEl = lines[lineNumber];
                    if (!tableRowEl)
                        continue;
                    tableRowEl.classList.add(constants_1.HighlightedLineToken);
                }
            }
        }
        preEl.classList.add(this.linesHighlightedClassToken);
        return lineNumbers !== null && lineNumbers !== void 0 ? lineNumbers : [];
    };
    HljsHighlighter.prototype.loadHljs = function () {
        return __awaiter(this, void 0, void 0, function () {
            var href;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        href = this.adapterOptions.hljs.scriptPath;
                        if (!!_global.hljs) return [3 /*break*/, 2];
                        return [4 /*yield*/, (0, load_script_css_1.loadScript)({
                                id: 'hljs-script',
                                src: href,
                            })];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    HljsHighlighter.prototype.loadLineNumberPlugin = function () {
        return __awaiter(this, void 0, void 0, function () {
            var href;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        href = this.adapterOptions.hljs.lineNumberPluginPath;
                        return [4 /*yield*/, (0, load_script_css_1.loadScript)({
                                id: 'hljs-line-numbers',
                                src: href,
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return HljsHighlighter;
}(base_highlighter_1.BaseHighlighter));
exports.HljsHighlighter = HljsHighlighter;


/***/ }),

/***/ 248:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.HljsLanguagesLoader = void 0;
var load_script_css_1 = __webpack_require__(978);
var languagesMap = {
    tcltk: 'tcl',
    tclsh: 'tcl',
    tk: 'tcl',
    pq: 'powerquery',
    mscript: 'powerquery',
    M: 'powerquery',
    wat: 'wasm',
    wast: 'wasm',
    webassembly: 'wasm',
};
var HljsLanguagesLoader;
(function (HljsLanguagesLoader) {
    var _this = this;
    var registerAlias = function (language) {
        var aliases = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            aliases[_i - 1] = arguments[_i];
        }
        var hljsLanguage = hljs.getLanguage(language);
        if (hljsLanguage) {
            hljs.registerAliases(aliases.filter(function (x) { return hljs.getLanguage(x) == null; }), { languageName: language });
            return true;
        }
        else {
            console.warn("Try to register [".concat(aliases.join(','), "] as aliases of ").concat(language, ", but ").concat(language, " is not defined."));
            return false;
        }
    };
    HljsLanguagesLoader.load = function (lang, options) { return __awaiter(_this, void 0, void 0, function () {
        var mappedLang, scriptPath, splits, url, err_1;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    lang = lang.toLowerCase().trim().replace('language-', '');
                    mappedLang = (_a = languagesMap[lang]) !== null && _a !== void 0 ? _a : lang;
                    if (!mappedLang || hljs.getLanguage(mappedLang)) {
                        registerAlias(mappedLang, lang);
                        return [2 /*return*/];
                    }
                    scriptPath = options.scriptPath;
                    splits = scriptPath.split('/');
                    splits.pop();
                    url = splits.join('/') + "/languages/".concat(mappedLang, ".min.js");
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, (0, load_script_css_1.loadScript)({
                            id: "hljs-language-".concat(mappedLang),
                            src: url,
                        })];
                case 2:
                    _b.sent();
                    registerAlias(mappedLang, lang);
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _b.sent();
                    console.warn('加载hljs语言定义脚本失败', err_1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); };
})(HljsLanguagesLoader || (HljsLanguagesLoader = {}));
exports.HljsLanguagesLoader = HljsLanguagesLoader;


/***/ }),

/***/ 931:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.PrismHighlighter = void 0;
var base_highlighter_1 = __webpack_require__(189);
var utils_1 = __webpack_require__(651);
var load_script_css_1 = __webpack_require__(978);
var constants_1 = __webpack_require__(743);
var _global = window;
/**
 * @public
 */
var PrismHighlighter = /** @class */ (function (_super) {
    __extends(PrismHighlighter, _super);
    function PrismHighlighter() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._linkAttr = {
            name: 'prismjs',
            value: '',
        };
        return _this;
    }
    Object.defineProperty(PrismHighlighter.prototype, "highlighterOptions", {
        get: function () {
            return this.adapterOptions.prism;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PrismHighlighter.prototype, "id", {
        get: function () {
            return 'prismjs';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PrismHighlighter.prototype, "enableCodeLineNumber", {
        get: function () {
            return this.adapterOptions.enableCodeLineNumber;
        },
        enumerable: false,
        configurable: true
    });
    PrismHighlighter.prototype.highlight = function (el) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var _b, preEl, codeEl;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this.ensureResourcesLoaded()];
                    case 1:
                        _c.sent();
                        _b = (_a = this.resolveContainerElements(el)) !== null && _a !== void 0 ? _a : [], preEl = _b[0], codeEl = _b[1];
                        if (!preEl || !codeEl)
                            return [2 /*return*/];
                        if (this.adapterOptions.enableCodeLineNumber) {
                            preEl.classList.add('line-numbers');
                        }
                        else {
                            preEl.classList.remove('line-numbers');
                            codeEl.classList.remove('line-numbers');
                        }
                        this.tryApplyLang(codeEl);
                        this.onHighlighting(this.id, preEl, codeEl);
                        this.filterCodeContent(codeEl);
                        (0, utils_1.adaptSql)(codeEl);
                        Prism.highlightElement(codeEl, false);
                        this.highlightLines(preEl);
                        this.onHighlighted(this.id, preEl, codeEl);
                        return [2 /*return*/];
                }
            });
        });
    };
    PrismHighlighter.prototype.highlightLines = function (preEl) {
        var _a, _b;
        var codeEl = preEl.querySelector('code');
        var linesToHighlight = this.resolveLinesToHighlight(codeEl) || this.resolveLinesToHighlight(preEl);
        if (!linesToHighlight)
            return [];
        var html = codeEl.innerHTML;
        var lineNumbersRowsHtml = (_b = (_a = codeEl.querySelector('.line-numbers-rows')) === null || _a === void 0 ? void 0 : _a.outerHTML) !== null && _b !== void 0 ? _b : '';
        if (lineNumbersRowsHtml) {
            html = html.replace(lineNumbersRowsHtml, '');
        }
        var lines = html.split('\n');
        linesToHighlight.forEach(function (lineNumber) {
            if (lineNumber < 0 || lineNumber >= lines.length)
                return;
            var lineContent = lines[lineNumber];
            lines[lineNumber] = "<span class=\"".concat(constants_1.HighlightedLineToken, "\">").concat(lineContent, "</span>");
        });
        codeEl.innerHTML = lines.join('\n') + lineNumbersRowsHtml;
        preEl.classList.add(this.linesHighlightedClassToken);
        return linesToHighlight;
    };
    PrismHighlighter.prototype.ensureResourcesLoaded = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, , 5]);
                        return [4 /*yield*/, this.loadPrismAsync()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, Promise.all([this.loadPrismAutoLoader(), this.loadPrismLineNumberPluginScript()])];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.loadStyles([this._linkAttr])];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        err_1 = _a.sent();
                        console.error(err_1);
                        return [2 /*return*/];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    PrismHighlighter.prototype.setTheme = function (theme, attributes, isDarkTheme) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.setTheme.call(this, theme, attributes, isDarkTheme)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.loadPrismLineNumberPluginStyle()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PrismHighlighter.prototype.loadPrismAsync = function () {
        return __awaiter(this, void 0, void 0, function () {
            var href;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _global.Prism = _global.Prism || {};
                        Prism.manual = true;
                        href = this.adapterOptions.prism.scriptPath;
                        return [4 /*yield*/, (0, load_script_css_1.loadScript)({
                                id: 'prismjs-script',
                                src: href,
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PrismHighlighter.prototype.loadPrismAutoLoader = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var loaded, href;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        loaded = !!((_a = _global.Prism.plugins) === null || _a === void 0 ? void 0 : _a.autoloader);
                        href = this.adapterOptions.prism.autoLoaderPluginPath;
                        if (!!loaded) return [3 /*break*/, 2];
                        return [4 /*yield*/, (0, load_script_css_1.loadScript)({
                                id: 'prismjs-autoloader-script',
                                src: href,
                            })];
                    case 1:
                        _b.sent();
                        _b.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    PrismHighlighter.prototype.loadPrismLineNumberPluginScript = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.enableCodeLineNumber)
                            return [2 /*return*/];
                        if (!this.adapterOptions.prism.lineNumberPluginPath) {
                            throw Error('lineNumberPluginPath not configured');
                        }
                        return [4 /*yield*/, (0, load_script_css_1.loadScript)({
                                id: 'prism-line-numbers-script',
                                src: this.adapterOptions.prism.lineNumberPluginPath,
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PrismHighlighter.prototype.loadPrismLineNumberPluginStyle = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (!this.enableCodeLineNumber)
                    return [2 /*return*/];
                if (!this.adapterOptions.prism.lineNumberStylePath) {
                    throw Error('lineNumberStylePath not configured');
                }
                (0, load_script_css_1.loadCss)({
                    id: 'prism-line-numbers-style',
                    href: this.adapterOptions.prism.lineNumberStylePath,
                    beforeElementCreateCallback: function (el) {
                        return (0, utils_1.setAttributes)(el, [
                            {
                                name: 'prismjs',
                                value: '',
                            },
                        ]);
                    },
                }).then();
                return [2 /*return*/];
            });
        });
    };
    return PrismHighlighter;
}(base_highlighter_1.BaseHighlighter));
exports.PrismHighlighter = PrismHighlighter;


/***/ }),

/***/ 651:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.removeAttributes = exports.setAttributes = exports.getElementRightSpacing = exports.getElementLeftSpacing = exports.adaptSql = exports.encodeHtml = void 0;
/**
 * @param html
 * @internal
 */
var encodeHtml = function (html) {
    var div = document.createElement('div');
    div.textContent = html;
    return div.innerHTML;
};
exports.encodeHtml = encodeHtml;
/**
 * @param el
 * @internal
 */
var adaptSql = function (el) {
    var _a;
    var classList = Array.from(el.classList);
    var classesToReplace = (_a = classList.filter(function (x) { return x.toLowerCase().endsWith('sql'); })) !== null && _a !== void 0 ? _a : [];
    for (var _i = 0, classesToReplace_1 = classesToReplace; _i < classesToReplace_1.length; _i++) {
        var c = classesToReplace_1[_i];
        el.classList.remove(c);
        el.classList.add('language-sql');
    }
};
exports.adaptSql = adaptSql;
var getElementLeftSpacing = function (el) {
    var computedStyle = getComputedStyle(el);
    return parseInt(computedStyle.paddingLeft, 10) + parseInt(computedStyle.marginLeft, 10);
};
exports.getElementLeftSpacing = getElementLeftSpacing;
var getElementRightSpacing = function (el) {
    var computedStyle = getComputedStyle(el);
    return parseInt(computedStyle.paddingRight, 10) + parseInt(computedStyle.marginRight, 10);
};
exports.getElementRightSpacing = getElementRightSpacing;
var setAttributes = function (el, attributes) {
    attributes === null || attributes === void 0 ? void 0 : attributes.forEach(function (attr) { return el.setAttribute(attr.name, attr.value); });
};
exports.setAttributes = setAttributes;
var removeAttributes = function (el, attributes) {
    attributes === null || attributes === void 0 ? void 0 : attributes.forEach(function (attr) { return el.removeAttribute(attr); });
};
exports.removeAttributes = removeAttributes;


/***/ }),

/***/ 465:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.HighlightersFactory = exports.PrismHighlighter = exports.HljsHighlighter = exports.BaseHighlighter = void 0;
var hljs_highlighter_1 = __webpack_require__(794);
Object.defineProperty(exports, "HljsHighlighter", ({ enumerable: true, get: function () { return hljs_highlighter_1.HljsHighlighter; } }));
var prism_highlighter_1 = __webpack_require__(931);
Object.defineProperty(exports, "PrismHighlighter", ({ enumerable: true, get: function () { return prism_highlighter_1.PrismHighlighter; } }));
var base_highlighter_1 = __webpack_require__(189);
Object.defineProperty(exports, "BaseHighlighter", ({ enumerable: true, get: function () { return base_highlighter_1.BaseHighlighter; } }));
var highlighters_factory_1 = __webpack_require__(285);
Object.defineProperty(exports, "HighlightersFactory", ({ enumerable: true, get: function () { return highlighters_factory_1.HighlightersFactory; } }));
__exportStar(__webpack_require__(907), exports);


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	__webpack_require__(408);
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__(465);
/******/ 	
/******/ 	return __webpack_exports__;
/******/ })()
;
});