var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { BaseHighlighter } from './base-highlighter';
import { adaptSql } from './utils';
import { HljsLanguagesLoader } from './hljs-languages-loader';
import { HighlightedLineToken, PrismjsEngineToken } from './constants';
import { loadScript } from '@cnblogs/load-script-css';
var _global = window;
/**
 * @public
 */
var HljsHighlighter = /** @class */ (function (_super) {
    __extends(HljsHighlighter, _super);
    function HljsHighlighter() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._linkAttr = {
            name: 'hljs',
            value: '',
        };
        return _this;
    }
    Object.defineProperty(HljsHighlighter.prototype, "highlighterOptions", {
        get: function () {
            return this.adapterOptions.hljs;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HljsHighlighter.prototype, "id", {
        get: function () {
            return 'highlight.js';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HljsHighlighter.prototype, "linesHighlightedClassToken", {
        get: function () {
            return 'hljs-lines-highlighted';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HljsHighlighter.prototype, "enableCodeLineNumber", {
        get: function () {
            return this.adapterOptions.enableCodeLineNumber;
        },
        enumerable: false,
        configurable: true
    });
    HljsHighlighter.prototype.ensureResourcesLoaded = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, this.loadHljs()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.loadStyles([this._linkAttr])];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        console.error(err_1);
                        return [2 /*return*/];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    HljsHighlighter.prototype.highlight = function (el) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var enableCodeLineNumber, _b, preEl, codeEl, err_2, lang;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this.ensureResourcesLoaded()];
                    case 1:
                        _c.sent();
                        enableCodeLineNumber = this.enableCodeLineNumber;
                        _b = (_a = this.resolveContainerElements(el)) !== null && _a !== void 0 ? _a : [], preEl = _b[0], codeEl = _b[1];
                        if (!preEl || !codeEl)
                            return [2 /*return*/];
                        preEl.classList.remove(PrismjsEngineToken);
                        _c.label = 2;
                    case 2:
                        _c.trys.push([2, 5, , 6]);
                        if (!enableCodeLineNumber) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.loadLineNumberPlugin()];
                    case 3:
                        _c.sent();
                        _c.label = 4;
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        err_2 = _c.sent();
                        console.error(err_2);
                        return [3 /*break*/, 6];
                    case 6:
                        this.onHighlighting(this.id, preEl, codeEl);
                        el.classList.remove('hljs-line-numbers');
                        lang = this.tryApplyLang(el);
                        this.filterCodeContent(el);
                        adaptSql(el);
                        return [4 /*yield*/, HljsLanguagesLoader.load(lang, this.highlighterOptions)];
                    case 7:
                        _c.sent();
                        hljs.highlightElement(el);
                        if (enableCodeLineNumber) {
                            if (hljs.lineNumbersValue) {
                                el.innerHTML = hljs.lineNumbersValue(el.innerHTML, {
                                    singleLine: true,
                                });
                                el.classList.add('hljs-line-numbers');
                            }
                            else {
                                console.error('failed to load hljs line numbers plugin!');
                            }
                        }
                        this.highlightLines(preEl);
                        codeEl.classList.add('hljs');
                        this.onHighlighted(this.id, preEl, codeEl);
                        return [2 /*return*/];
                }
            });
        });
    };
    HljsHighlighter.prototype.highlightLines = function (preEl) {
        var codeEl = preEl.querySelector('code');
        if (!codeEl)
            return [];
        var lineNumbers = this.resolveLinesToHighlight(codeEl);
        if (lineNumbers == null || lineNumbers.length <= 0)
            return [];
        var html = codeEl.innerHTML;
        var enableCodeLineNumber = this.adapterOptions.enableCodeLineNumber;
        switch (enableCodeLineNumber) {
            case false:
                {
                    var lines = html.split('\n');
                    for (var _i = 0, lineNumbers_1 = lineNumbers; _i < lineNumbers_1.length; _i++) {
                        var lineNumber = lineNumbers_1[_i];
                        if (lineNumber < 0 || lineNumber >= lines.length)
                            continue;
                        var lineContent = lines[lineNumber];
                        if (lineContent == null)
                            continue;
                        lines[lineNumber] = "<span class=\"".concat(HighlightedLineToken, "\">").concat(lineContent, "</span>");
                    }
                    codeEl.innerHTML = "<span class=\"hljs-lines-highlight-wrapper\">".concat(lines.join('\n'), "</span>");
                }
                break;
            default: {
                var lines = Array.from(codeEl.querySelectorAll('tr'));
                for (var _a = 0, lineNumbers_2 = lineNumbers; _a < lineNumbers_2.length; _a++) {
                    var lineNumber = lineNumbers_2[_a];
                    if (lineNumber < 0 || lineNumber >= lines.length)
                        continue;
                    var tableRowEl = lines[lineNumber];
                    if (!tableRowEl)
                        continue;
                    tableRowEl.classList.add(HighlightedLineToken);
                }
            }
        }
        preEl.classList.add(this.linesHighlightedClassToken);
        return lineNumbers !== null && lineNumbers !== void 0 ? lineNumbers : [];
    };
    HljsHighlighter.prototype.loadHljs = function () {
        return __awaiter(this, void 0, void 0, function () {
            var href;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        href = this.adapterOptions.hljs.scriptPath;
                        if (!!_global.hljs) return [3 /*break*/, 2];
                        return [4 /*yield*/, loadScript({
                                id: 'hljs-script',
                                src: href,
                            })];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    HljsHighlighter.prototype.loadLineNumberPlugin = function () {
        return __awaiter(this, void 0, void 0, function () {
            var href;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        href = this.adapterOptions.hljs.lineNumberPluginPath;
                        return [4 /*yield*/, loadScript({
                                id: 'hljs-line-numbers',
                                src: href,
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return HljsHighlighter;
}(BaseHighlighter));
export { HljsHighlighter };
