"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeAttributes = exports.setAttributes = exports.getElementRightSpacing = exports.getElementLeftSpacing = exports.adaptSql = exports.encodeHtml = void 0;
/**
 * @param html
 * @internal
 */
var encodeHtml = function (html) {
    var div = document.createElement('div');
    div.textContent = html;
    return div.innerHTML;
};
exports.encodeHtml = encodeHtml;
/**
 * @param el
 * @internal
 */
var adaptSql = function (el) {
    var _a;
    var classList = Array.from(el.classList);
    var classesToReplace = (_a = classList.filter(function (x) { return x.toLowerCase().endsWith('sql'); })) !== null && _a !== void 0 ? _a : [];
    for (var _i = 0, classesToReplace_1 = classesToReplace; _i < classesToReplace_1.length; _i++) {
        var c = classesToReplace_1[_i];
        el.classList.remove(c);
        el.classList.add('language-sql');
    }
};
exports.adaptSql = adaptSql;
var getElementLeftSpacing = function (el) {
    var computedStyle = getComputedStyle(el);
    return parseInt(computedStyle.paddingLeft, 10) + parseInt(computedStyle.marginLeft, 10);
};
exports.getElementLeftSpacing = getElementLeftSpacing;
var getElementRightSpacing = function (el) {
    var computedStyle = getComputedStyle(el);
    return parseInt(computedStyle.paddingRight, 10) + parseInt(computedStyle.marginRight, 10);
};
exports.getElementRightSpacing = getElementRightSpacing;
var setAttributes = function (el, attributes) {
    attributes === null || attributes === void 0 ? void 0 : attributes.forEach(function (attr) { return el.setAttribute(attr.name, attr.value); });
};
exports.setAttributes = setAttributes;
var removeAttributes = function (el, attributes) {
    attributes === null || attributes === void 0 ? void 0 : attributes.forEach(function (attr) { return el.removeAttribute(attr); });
};
exports.removeAttributes = removeAttributes;
